<?php


if (!defined('_PS_VERSION_'))
	exit;


class Oddzwaniaj extends Module {

  public function __construct() {
        $this->name = 'oddzwaniaj';
        $this->tab = 'front_office_features';
        $this->version = 1.0;
        $this->author = 'Oddzwaniaj.pl';
        $this->need_instance = 0;

        parent::__construct();

        $this->displayName = $this->l('Oddzwaniaj.pl - widget kontaktowy');
        $this->description = $this->l('Zachęcaj klientów i docieraj do szerszej grupy odbiorców wykorzystując mechanizmy społeczne i komunikacje wielokanałową.');

        $this->confirmUninstall = $this->l('Czy napewno chcesz odinstalować?');
  }


  public function install()
  {

    if (Shop::isFeatureActive())
      Shop::setContext(Shop::CONTEXT_ALL);

    if (!parent::install() ||  !$this->registerHook('footer') || !Configuration::updateValue('ODDZWANIAJ_ID', ''))
      return false;
    
      return true;
  }
  
  public function uninstall() {
    if (!parent::uninstall() || !$this->unregisterHook('footer') || !Configuration::deleteByName('ODDZWANIAJ_ID')) {
      return false;
    }

    return true;
  }


  public function getContent() {
    $output = null;

    if (Tools::isSubmit('submit'.$this->name)) {
      $id = strval(Tools::getValue('ODDZWANIAJ_ID'));
      
      if (!$id || empty($id) || !Validate::isGenericName($id))
        $output .= $this->displayError($this->l('Błędne id'));
      else {
        Configuration::updateValue('ODDZWANIAJ_ID', $id);
        $output .= $this->displayConfirmation($this->l('Zapisano zmiany'));
      }
    }
    return $output.$this->displayForm();
  }

  public function displayForm() {
    // Get default language
    $default_lang = (int)Configuration::get('PS_LANG_DEFAULT');
     
    // Init Fields form array
    $fields_form[0]['form'] = array(
        'legend' => array(
            'title' => $this->l('Ustawienia'),
        ),
        'input' => array(
            array(
                'type' => 'text',
                'label' => $this->l('ID widgetu Oddzwaniaj'),
                'name' => 'ODDZWANIAJ_ID',
                'size' => 10,
                'required' => true
            )
        ),
        'submit' => array(
            'title' => $this->l('Zapisz'),
            'class' => 'btn btn-default pull-right'
        )
    );
     
    $helper = new HelperForm();
     
    // Module, token and currentIndex
    $helper->module = $this;
    $helper->name_controller = $this->name;
    $helper->token = Tools::getAdminTokenLite('AdminModules');
    $helper->currentIndex = AdminController::$currentIndex.'&configure='.$this->name;
     
    // Language
    $helper->default_form_language = $default_lang;
    $helper->allow_employee_form_lang = $default_lang;
     
    // Title and toolbar
    $helper->title = $this->displayName;
    $helper->show_toolbar = true;        // false -> remove toolbar
    $helper->toolbar_scroll = true;      // yes - > Toolbar is always visible on the top of the screen.
    $helper->submit_action = 'submit'.$this->name;
    $helper->toolbar_btn = array(
        'save' =>
        array(
            'desc' => $this->l('Save'),
            'href' => AdminController::$currentIndex.'&configure='.$this->name.'&save'.$this->name.
            '&token='.Tools::getAdminTokenLite('AdminModules'),
        ),
        'back' => array(
            'href' => AdminController::$currentIndex.'&token='.Tools::getAdminTokenLite('AdminModules'),
            'desc' => $this->l('Back to list')
        )
    );
     
    // Load current value
    $helper->fields_value['ODDZWANIAJ_ID'] = Configuration::get('ODDZWANIAJ_ID');
     
    return $helper->generateForm($fields_form);
  }

  public function hookFooter() {
    $id = Configuration::get('ODDZWANIAJ_ID');

    if ($id) {
      $script = '<script>';
      $script .= 'window.oddzwaniajSettings = {';
      $script .= 'oddzwaniajId: "' . $id . '"';
      $script .= '};';
      $script .= '</script>';
      $script .= '<script>';
      $script .= 'window.addEventListener("load", function () {var e = document, t = e.createElement("script"); t.type = "text/javascript", t.async = !0, t.src = "https://cdn.oddzwaniaj.pl/js/widget.js"; var n = e.getElementsByTagName("script")[0]; n.parentNode.insertBefore(t, n)}, !1);';
      $script .= '</script>';

      return $script;

      
    } else {
      return '';
    }
  }
}